;QB usage

;FUNC values:
;77h=doio (call this frequently for packet processing)
;00h=Make IP info table
;01h=Listen connections
;02h=Get data
;03h=Send data
;04h=Close connection
;05h=Extract IP from table
;06h=Get Activity based on Handle
;07h=Find HTTP headers **

;QB Entry: Call absolute(seg(struct),offs(struct),funcno,offs(code))
;Struct is based on function. Special call absolutes apply to starred functions
PUSH BP
MOV BP, SP
PUSH ES
PUSH DI
PUSH DS
PUSH SI
MOV BX,[BP+08h]
mov SI,[BX]
MOV BX,[BP+0Ah] ;DS:SI=struct entry point
mov DS,[BX]
MOV BX,[BP+06h] ;AX=wanted function
mov AX,[BX]
cmp AL,77h ;func 77=do IO (call this often)
jne intio
  mov AX,0200h
  call runint
  mov DH,0h
  mov [DS:SI],AX   ;S+00=Free Packets on input q
  mov [DS:SI+2],CX ;S+02=Free packets on output q
  MOV [DS:SI+4],DX ;S+04=error code
  jmp endit
intio:
mov AH,0h
cmp AL,0h ;func 0=driver info
jne ipinfo
  mov DI,[DS:SI]   ;S+00=buffer offs
  mov ES,[DS:SI+2] ;S+02=buffer seg
  mov CX,[DS:SI+4] ;S+04=buffer sz
  mov AX,0400h 
  call runint
  mov [DS:SI+6],CX ;S+06=actual buffer sz
  jmp endit
ipinfo:
cmp AL,1h ;func 1=start listen
jne tcplisten
  mov BX,[DS:SI]   ;S+00=wanted server port
  mov DX,[DS:SI+2] ;S+02=timeout
  mov AX,0h
  push DS
  push SI
  mov DS,AX
  mov SI,AX
  mov AX,1001h ;open as listener. 1000h = connect instead
  call runint
  mov DH,0h
  pop SI
  pop DS
  mov [DS:SI+4],BX ;S+06=handle
  mov [DS:SI+6],DX ;S+08=error code
  jmp endit
tcplisten:
cmp AL,2h ;func 2=get data
jne tcpget
  mov ax,1201h ;get data
  jmp tcpdio
tcpget:
cmp AL,3h ;func 3=put data
jne tcpput
  mov ax,1304h ;put data + wait ack
  jmp tcpdio
tcpput:
cmp AL,4h ;func 4=close tcp
jne tcpclose
  mov BX,[DS:SI+0] ;S+00=handle
  mov DX,[DS:SI+2] ;S+02=timeout
  mov AX,[DS:SI+4] ;S+04=close type. 0=normal, 1=abort
  and AX,0001h
  or ax,1100h
  call runint
  mov DH,0h
  mov [DS:SI+6],DX ;S+06=error code
  jmp endit
tcpclose:
cmp AL,5h ;func 5=extract IP address from table
jne noipdat
  jmp extrip
noipdat:
cmp AL,6h ;function 6=get status on handle
jne nostat
  mov BX,[DS:SI+0] ;S+00=handle
  mov ax,1400h ;get status
  call runint
  mov DH,0h
  mov [DS:SI+2],DX ;S+02=status
  mov [DS:SI+4],AX ;S+04=bytes to read
  mov [DS:SI+6],CX ;S+06=bytes being sent
  mov [DS:SI+8],DI ;S+08=IP table offs
  mov [DS:SI+0Ah],ES ;S+0A=IP table seg
  jmp endit
nostat:
cmp AL,7h ;function 7=find http header section
jne nohttp
  jmp HTTPhead
nohttp:
endit:
POP SI
POP DS
POP DI
POP ES
POP BP
RETF 10h

;TCP get or put
tcpdio:
  mov BX,[DS:SI+0] ;S+00=handle
  mov CX,[DS:SI+2] ;S+02=wanted size
  mov DX,[DS:SI+4] ;S+04=timeout
  mov ES,[DS:SI+6] ;S+06=Buffer seg
  mov DI,[DS:SI+8] ;S+08=Buffer offs
  call runint
  mov DH,0h
  mov [DS:SI+0Ah],DX ;S+0A=status
  mov [DS:SI+0Ch],AX ;S+0C=bytes passed
jmp endit

;extract IP
extrip:
  mov AL,[DS:SI]   ;S+00=our ip as 32-bit
  mov BL,[DS:SI+1] ;S+04=our ip as 4 ints
  mov CL,[DS:SI+2]   
  mov DL,[DS:SI+3]   
  mov [DS:SI+4],DL
  mov [DS:SI+6],CL
  mov [DS:SI+8],BL
  mov [DS:SI+0Ah],AL
jmp endit

;find HTTP header
HTTPhead:
  MOV BX,[BP+0Ch] ;Size
  mov CX,[bx]
  mov DX,0h
  nextsc:
    inc DX
    MOV BX,[BP+08h] ;DS:SI = source
    mov AX,[bx]
    add AX,DX ;source pointer +1, string size, -1
    mov SI,AX
    MOV BX,[BP+0Ah] 
    mov DS,[bx]
    MOV BX,[BP+0Eh] ;ES:DI = dest (but put enter key here)
    mov DI,[bx]
    MOV BX,[BP+10h] 
    mov ES,[bx]
    cmpsw
    jne nfound
    cmpsw
    jne nfound
      ;found 2 enters
      mov AX,1h
      jmp httpres
    nfound:
  loop nextsc
  mov AX,0h
  httpres:
  MOV BX,[BP+12h]  ;1=found, 0=not found
  mov [bx],AX
  MOV BX,[BP+0Ch]  ;Location found or original string length if not found
  mov [bx],DX
jmp endit

runint:
int 61h
ret